const schemeName = "fdm";

const {Cc,Ci,Cu,components} = require("chrome");
const nsIProtocolHandler = Ci.nsIProtocolHandler;
var { Class } = require('sdk/core/heritage');
var { Unknown, Factory } = require('sdk/platform/xpcom');
var xpcom = require('sdk/platform/xpcom');

Cu.import("resource://gre/modules/XPCOMUtils.jsm");

var FdmSchemeHandlerUser = new Object;

FdmSchemeHandlerUser.onNewRequest = function(aURI) 
{
    console.log(aURI.spec);
};

var FdmSchemeHandler = Class({
    extends: Unknown,
    interfaces: ['nsIProtocolHandler'],
    get wrappedJSObject() this,

    scheme: schemeName,

    protocolFlags: nsIProtocolHandler.URI_NORELATIVE |
                 nsIProtocolHandler.URI_NOAUTH |
                 nsIProtocolHandler.URI_LOADABLE_BY_ANYONE,

    newURI: function(aSpec, aOriginCharset, aBaseUri)
    {
        var uri = Cc["@mozilla.org/network/simple-uri;1"].createInstance(Ci.nsIURI);
        uri.spec = aSpec;
        return uri;
    },

    newChannel: function(aUri)
    {
        FdmSchemeHandlerUser.onNewRequest(aUri);
        var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
        return ios.newChannel("javascript:void", null, null);
    }
});

var FdmSchemeHandlerContractId = "@mozilla.org/network/protocol;1?name=" + schemeName;

var FdmSchemeHandlerFactory = Factory({
    contract: FdmSchemeHandlerContractId,
    Component: FdmSchemeHandler,
    register: false,
    unregister: false,
});

function register(reg)
{
    if (reg)
        xpcom.register(FdmSchemeHandlerFactory);
    else
        xpcom.unregister(FdmSchemeHandlerFactory);
}

function registerCallback(fn)
{
    var prev = FdmSchemeHandlerUser.onNewRequest;
    FdmSchemeHandlerUser.onNewRequest = fn;
    return prev;
}

exports.register = register;
exports.registerCallback = registerCallback;
exports.FdmSchemeHandlerUser = FdmSchemeHandlerUser;
