const misc = require("./misc.js");
var fdmbh = require("./fdm_bh_ipc.js");
const FdmScheme = require("./fdmscheme.js");

function FdmSchemeHandler(ipcmgr)
{
    this.ipcmgr = ipcmgr;
}

FdmSchemeHandler.prototype.onNewRequest = function (aURI)
{
    var download = new misc.DownloadInfo(aURI.spec);
    var task = new fdmbh.FdmBhCreateDownloadsTask;
    task.addDownload(download);
    task.create_downloads.catchedDownloads = "0";
    task.create_downloads.waitResponse = "0";
    this.ipcmgr.sendTask(task);
}

FdmSchemeHandler.prototype.register = function(reg)
{
    if (reg)
        FdmScheme.registerCallback(this.onNewRequest.bind(this));
    FdmScheme.register(reg);
}

exports.FdmSchemeHandler = FdmSchemeHandler;